classdef Element < MSS.TreeNode
   
   
   
   properties
      
      tag
      
   end % properties
   
   
   properties (SetAccess = protected)

      type
      cliques = {};
      
   end % properties (Set protected)
   
   
   
   methods

      
      function obj = Element(type)
         
         assert(ischar(type),'Element type must be a string');
         type = regexp(type,'^[a-zA-Z]\w*$','match','once');
         assert(not(isempty(type)),'Invalid element type');
         obj.type = type;
         
      end % function
      
      
      function obj = set.tag(obj,value)
         
         assert(ischar(value),'Element tag must be a string');
         value = regexp(value,'^[a-zA-Z]\w*$','match','once');
         assert(not(isempty(value)),'Invalid element tag');
         obj.tag = value;
         
      end % function
      
      
      function obj = addToClique(obj,value)
         
         assert(ischar(value),'Clique name must be a string');
         value = regexp(value,'^[a-zA-Z]\w*$','match','once');
         assert(not(isempty(value)),'Invalid clique name');
         if not(obj.isInClique(value))
            obj.cliques{end+1} = value;
         end
         
      end % function
      
      
      function reply = isInClique(obj,clique)
         
         reply = ismember(clique,obj.cliques);
         
      end % function
      
      
   end % methods
      
   
   
end % classdef