classdef RuleSet < handle
   
   
   
   properties
      
      selectors
      props = {}
      values = {}
      
   end % properties
   
   
   
   methods
      
      
      function obj = RuleSet()
      end % function
      
      
      function obj = addSelector(obj,varargin)
         
         for k = 1:length(varargin)
            assert(isa(varargin{k},'MSS.Selector'));
            if isempty(obj.selectors)
               obj.selectors = varargin{k};
            else
               obj.selectors(end+1) = varargin{k};
            end
         end
         
      end % function
      
      
      function obj = addDeclaration(obj,varargin)
         
         for k = 1:2:length(varargin)
            if obj.isValidProperty(varargin{k})
               obj.props{end+1} = varargin{k};
               obj.values{end+1} = varargin{k+1};
            end
         end
         
      end % function
      
      
      function reply = isValidProperty(obj,prop)
         
         badChars = regexp(prop,'[^\w]','match');
         reply = isempty(badChars);
         
      end % function
      
      
      function display(obj)
         
         for i = 1:numel(obj)
            
            if isempty(obj(i).selectors)
               fprintf('\n   Empty Rule.\n');
            else
               
               fprintf('\n');
               
               for k = 1:length(obj(i).selectors)
                  fprintf('   ');
                  if k < length(obj(i).selectors)
                     fprintf('%s, \n',obj(i).selectors(k).toString());
                  else
                     fprintf('%s ',obj(i).selectors(k).toString());
                  end
               end % for k
               
               if not(isempty(obj(i).props))
                  fprintf('{\n');
                  for k = 1:length(obj(i).props)
                     fprintf('      %s: %s;\n',obj(i).props{k},obj(i).values{k});
                  end
                  fprintf('   }\n');
               else
                  fprintf('{ }\n');
               end
               
            end % if
            
         end % for i
         
         fprintf('\n');
         
      end % function
      
      
   end % methods
   
   
   
end % classdef