classdef div < MSS.Element
   
   properties
      box
   end
   
   methods
   
      function obj = div(varargin)
         obj = obj@MSS.Element('div');
         obj.box = MSS.FrameBox(obj);
         
         set(obj.box,'Width','auto');
         set(obj.box,'Height','auto');
         set(obj.box,'Margin','auto');
         
         fig = MSS.gcf();
         if isempty(varargin)
            fig.addChild(obj);
            fig.box.addChild(obj.box);
         else
            left = fig.getChildIndex(varargin{1});
            right = fig.getChildIndex(varargin{end});
            fig.insertGeneration(obj,left,right);
            fig.box.insertGeneration(obj.box,left,right);
         end
      end
      
      function set(obj,varargin)
         set(obj.box,varargin{:})
      end
      
      function value = get(obj,varargin)
         value = get(obj.box,varargin{:});
      end
      
      function update(obj)
         
         for k = 1:obj.numChildren()
            obj.children{k}.update();
         end
         
      end % function
      
      
      function delete(obj)
         obj.parent.removeChild(obj);
         obj.box.parent.removeChild(obj.box);
         for child = obj.children
            if isvalid(child{1})
               delete(child{1});
            end
         end
      end % function
      
   end
   
end