classdef lineseries < MSS.Element
   
   properties (SetAccess=protected)
      handle
   end %properties
   
   methods
      
      function obj = lineseries(client)
         obj = obj@MSS.Element('lineseries');
         obj.handle = client;
      end
      
      function set(obj,property,value,varargin)
         
         switch lower(property)
            
            case {'linewidth','markersize'}
               value = MSS.Converter.standardizeLengths(value);
               set(obj.handle,property,value{:});
               
            case {'color','markerfacecolor'}
               value = MSS.Converter.standardizeColors(value);
               set(obj.handle,property,value{:});
               
            otherwise
               set(obj.handle,property,value)
               
         end
         
         if not(isempty(varargin))
            set(obj,varargin{:})
         end
         
      end % function set
      
      function value = get(obj,varargin)
         value = get(obj.handle,varargin{:});
      end
      
      function update(obj)
      end
      
   end % methods
   
   
end